'''
Created on Sep 12, 2019 @author: levente.marton
'''
import openpyxl as xl
import xlrd
import re
from argparse import ArgumentParser
from collections import defaultdict

class Cielify(object):
    '''
    classdocs
    '''
    def __init__(self, wb1_name=None):
        '''
        Constructor
        '''
        self.wb_name = wb1_name
        if self.wb_name:
            self.wb1 = xl.load_workbook(filename=wb1_name)
            self.ws1 = self.wb1.worksheets[0]
            self.last_row = self.ws1.max_row
            self._tip = {'stoc': 1, 'serviciu': 0}
            self._tip_account = defaultdict(lambda: 'Materiale consumabile')
            self._accounts = {'Marfa in depozit': 'Marfuri', 'Alte materiale consumabile': 'Materiale consumabile'}
            self._partners = {'Partener tipic': 'Sablon de cont implicit'}
            self._tip_account.update(self._accounts)
            self._residance = 'Romania'
            self._monede = {'lei': 'RON', 'EUR': 'EUR', 'USD': 'USD', 'HUF': 'HUF'}
            self._attr_fiscal = re.compile('[A-Z]*')

    def convert_xls_to_xlsx(self, xls_file):
        self.xls_file = xls_file
        xls = xlrd.open_workbook(filename=self.xls_file)
        xlsx = xl.Workbook()
        sheet_names = xls.sheet_names()
        for sheet_index in range(len(sheet_names)):
            sheet_xls = xls.sheet_by_name(sheet_names[sheet_index])
            if sheet_index == 0:
                sheet_xlsx = xlsx.active
                sheet_xlsx.title = sheet_names[sheet_index]
            else:
                sheet_xlsx = xlsx.create_sheet(title=sheet_names[sheet_index])
            for row in range(1, sheet_xls.nrows+1 ):
                for col in range(1, sheet_xls.ncols+1):
                    print(sheet_xls.cell_value(row - 1, col - 1))
                    sheet_xlsx.cell(row=row , column=col, value=sheet_xls.cell_value(row - 1, col - 1))
            for i in sheet_xlsx[f'A2:A{sheet_xlsx.max_row}']:
                i[0].number_format = '@'
        self.converted_file = xls_file[:-3] + 'xlsx'
        dest_file = xls_file[:-3] + 'xlsx'
        xlsx.save(dest_file)
        return Cielify(dest_file)

    def _account_wrapper(self, **kwargs):
        wbs = {}
        n = 1
        for names, wbooks in kwargs.items():
            names = xl.load_workbook(filename=wbooks)
            wbs[f'wb{n}'] = names
            n+=1
        ws1 = wbs['wb1'].worksheets[0]
        ws1.insert_cols(4)
        area = zip(ws1[f'A1:A{ws1.max_row}'], ws1[f'B1:B{ws1.max_row}'], ws1[f'C1:C{ws1.max_row}'], ws1[f'D1:D{ws1.max_row}'])
        for a, b, c, d in area:
            if a[0].value:
                d[0].value = a[0].value
            elif b[0].value:
                d[0].value = b[0].value
            elif c[0].value:
                d[0].value = c[0].value
        ws1.delete_cols(1, 3)
        wbs['wb1'].save('Plan de conturi_ciel_2020_test.xlsx')
        accounts_ment = ws1[f'A2:A{ws1.max_row}']
        self.accounts_ment = accounts_ment
        return self.accounts_ment

    def _gest_wrapper(self, **kwargs):
        wbs = {}
        n = 1
        for names, wbooks in kwargs.items():
            names = xl.load_workbook(filename=wbooks)
            wbs[f'wb{n}'] = names
            n+=1
        ws1 = wbs['wb1'].worksheets[0]


    def _convert_date(self, columns: tuple) -> 'returns nothing':
        self.columns = columns
        for i, e in self.columns:
            if e[0].value:
                i[0].value = e[0].value[-4:] \
                + e[0].value[3:5] \
                + e[0].value[:2]
        # return True

    def convert_balance_advance(self):
        self.ws1.insert_cols(2)
        self.ws1['B1'].value = self.ws1['C1'].value
        colBC = zip(self.ws1[f'B2:B{self.last_row}'], self.ws1[f'C2:C{self.last_row}'])
        self._convert_date(colBC)
        self.ws1.delete_cols(3)
        for ammount in self.ws1[f'D2:D{self.last_row}']:
            ammount[0].value = round(abs(ammount[0].value), 2)
        self.ws1['E1'].value = 'Deviza -Moneda'
        for deviz in self.ws1[f'E2:E{self.last_row}']:
            deviz[0].value = self._monede[deviz[0].value]
        for currency in self.ws1[f'E2:F{self.last_row}']:
            if currency[0].value == 'RON':
                currency[1].value = None
        self.wb1.save('datorii_avans_2020_test.xlsx')
        return True

    def convert_balance(self):
        self.ws1.insert_cols(2)
        self.ws1.insert_cols(4)
        self.ws1['B1'].value = self.ws1['C1'].value
        colB = self.ws1[f'B2:B{self.last_row}']
        colC = self.ws1[f'C2:C{self.last_row}']
        self.ws1['D1'].value = self.ws1['E1'].value
        colD = self.ws1[f'D2:D{self.last_row}']
        colE = self.ws1[f'E2:E{self.last_row}']
        colBC = zip(colB, colC)
        colDE = zip(colD, colE)
        self._convert_date(colBC)
        self._convert_date(colDE)
        self.ws1.delete_cols(3)
        self.ws1.delete_cols(4)
        for r in self.ws1[f'F2:H{self.last_row}']:
            r[0].value = round(r[0].value, 2)
            r[1].value = round(r[1].value, 2)
            r[2].value = round(r[2].value, 2)
        for c in self.ws1[f'I2:J{self.last_row}']:
            c[0].value = self._monede[c[0].value]
            if c[0].value == 'RON':
                c[1].value = None
        self.wb1.save('datorii_test.xlsx')
        return True

    def convert_articles(self, account_table):
        # for this we need account table from ciel with headers
        # s1    s2    s3    Nume    Traducere    Tip cont    Utilizabil    Sintetic
        # the export is not ok we have to copy data to a new sheet
        # and delete the old one
        self.ws1.insert_cols(1)
        self.ws1.insert_cols(9)
        self.ws1['I1'] = 'Cont venituri servicii'
        self.ws1['J1'] = 'Cont cheltuieli servicii'
        self.ws1['A1'] = 'Cod'
        col_stockable = self.ws1[f'G2:G{self.last_row}']
        col_category = self.ws1[f'F2:F{self.last_row}']
        col_cod = self.ws1[f'A2:A{self.last_row}']
        colB = self.ws1[f'B2:B{self.last_row}']
        colC = self.ws1[f'C2:C{self.last_row}']
        colABC = zip(col_cod, colB, colC)
        for i in col_stockable:
            i[0].value = self._tip[i[0].value]
        for i in col_category:
            if i[0].value == '...':
                i[0].value = ''
        for a, b, c in colABC:
            if c[0].value:
                a[0].value = c[0].value
            else:
                a[0].value = b[0].value
                a[0].value = str(a[0].value)
        self.ws1.delete_cols(2)
        self.ws1.delete_cols(2)
        col_sablon = self.ws1[f'F2:F{self.last_row}']
        col_st_sablon = zip(col_stockable, col_sablon)
        for s, i in col_st_sablon:
            if s[0].value == 1:
                i[0].value = self._tip_account[i[0].value]
        col_expens = self.ws1[f'H2:H{self.last_row}']
        col_income = self.ws1[f'G2:G{self.last_row}']
        col_inc_exp = zip(col_income, col_expens)
        for i, e in col_inc_exp:
            if e[0].value:
                if e[0].value.startswith('6'):
                    e[0].value = e[0].value
                else:
                    i[0].value = e[0].value
                    e[0].value = None
        acc_symbols = self._account_wrapper(wb1=account_table)
        symbols = set()
        for symbol in acc_symbols:
            if symbol[0].value:
                symbols.add(symbol[0].value)
        col_st_inc = zip(col_stockable, col_income)
        for s, i in col_st_inc:
            if s[0].value == 0:
                for symbol in symbols:
                    if i[0].value:
                        if symbol[:3] in i[0].value:
                            i[0].value = symbol
            elif s[0].value == 1:
                i[0].value = None
        col_st_exp = zip(col_stockable, col_expens)
        for s, i in col_st_exp:
            if s[0].value == 0:
                for symbol in symbols:
                    if i[0].value:
                        if symbol[:3] in i[0].value:
                            i[0].value = symbol
        self.wb1.save('articole_2020_test.xlsx')
        return True

    def convert_stock(self, depo_table):
        # for this we need depo table from ciel
        self.ws1.insert_cols(2)
        self.ws1['B1'].value = 'Cod articol'
        area_cod = self.ws1[f'B2:D{self.last_row}']
        for cod in area_cod:
            if cod[2].value:
                cod[0].value = cod[2].value
            else:
                cod[0].value = cod[1].value
                cod[0].number_format = '@'
        self.ws1.delete_cols(3)
        self.ws1.delete_cols(3)
        wb2 = xl.load_workbook(depo_table)
        ws2 = wb2.worksheets[0]
        depo_dict = {i[1].value: i[0].value for i in ws2[f'A2:B{ws2.max_row}']}
        for c in self.ws1[f'A2:A{self.last_row}']:
            if c[0].value:
                c[0].value = depo_dict[c[0].value]
        for t in self.ws1[f'C2:C{self.last_row}']:
            t[0].value = self._tip_account[t[0].value]
        self.ws1.insert_cols(4)
        self.ws1['D1'].value = 'Lot'
        for p in self.ws1[f'G2:G{self.last_row}']:
            p[0].value = round(p[0].value, 2)
        for sn in self.ws1[f'D2:E{self.last_row}']:
            s = ''
            if sn[1].value:
                if '(' in sn[1].value:
                    sn[0].value = sn[1].value
                    sn[1].value = None
            if sn[0].value:
                for n in sn[0].value:
                    if n != '(':
                        s += n
                    else:
                        break
                sn[0].value = s
                sn[0].number_format = '@'
            if sn[1].value:
                if '; ' in sn[1].value:
                    sn[1].value = sn[1].value.replace('; ', ',')
        self.wb1.save('stock_2020_test.xlsx')
        return True

    def convert_partners(self, country_src):
        # for this we need coubtries from ciel (Tari.xlsx)
        colL= self.ws1[f'L2:L{self.last_row}']
        colK = self.ws1[f'K2:K{self.last_row}']
        colKL = zip(colK, colL)
        for t1, t2 in colKL:
            if t1[0].value != 0:
                t2[0].value = t1[0].value
        self.ws1.delete_cols(11)
        self.ws1.insert_cols(3)
        self.ws1.insert_cols(9)
        self.ws1.insert_cols(10)
        self.ws1['C1'].value = 'Atribut fiscal'
        self.ws1['I1'].value = 'Tara'
        self.ws1['J1'].value = 'Rezidenta'
        for attribute in self.ws1[f'C2:D{self.last_row}']:
            if attribute[1].value:
                attr = self._attr_fiscal.search(str(attribute[1].value[:2]))
                attribute[0].value = attr.group()
        wb_2 = xl.load_workbook(filename=country_src)
        ws_2 = wb_2.worksheets[0]
        d = {t[2].value: [t[0].value, t[1].value] for t in ws_2[f'A2:C{ws_2.max_row}']}
        d1 = defaultdict(lambda: None)
        d1.update(d)
        for code, country, residance in zip(self.ws1[f'C2:C{self.last_row}'], self.ws1[f'I2:I{self.last_row}'], self.ws1[f'J2:J{self.last_row}']):
            if code[0].value:
                if d1[code[0].value]:
                    country[0].value = d1[code[0].value][0]
                    residance[0].value = d1[code[0].value][1]
            else:
                country[0].value = self._residance
                residance[0].value = self._residance
        self.wb1.save('parteneri_2020_test.xlsx')
        return True
