import openpyxl as xl
import xlrd
from argparse import ArgumentParser

parser = ArgumentParser()
parser.add_argument('-f', '--filename', type=str, default='parteneri.xls',
                    help='filename to convert')

args = vars(parser.parse_args())

def xls_to_xlsx(src_file):
    xls = xlrd.open_workbook(filename=src_file)
    xlsx = xl.Workbook()
    sheet_names = xls.sheet_names()
    for sheet_index in range(len(sheet_names)):
        sheet_xls = xls.sheet_by_name(sheet_names[sheet_index])
        if sheet_index == 0:
            sheet_xlsx = xlsx.active
            sheet_xlsx.title = sheet_names[sheet_index]
        else:
            sheet_xlsx = xlsx.create_sheet(title=sheet_names[sheet_index])
        for row in range(1, sheet_xls.nrows+1 ):
            for col in range(1, sheet_xls.ncols+1):
                print(sheet_xls.cell_value(row - 1, col - 1))
                sheet_xlsx.cell(row=row , column=col, value=sheet_xls.cell_value(row - 1, col - 1))
        for i in sheet_xlsx[f'A2:A{sheet_xlsx.max_row}']:
            i[0].number_format = '@'
    dest_file = src_file[:-3] + 'xlsx'
    xlsx.save(dest_file)
    return dest_file

if __name__ == '__main__':
    xls_to_xlsx(args['filename'])
