import os
import platform
import subprocess as sp
from time import sleep
import openpyxl as xl
from win32com.client import Dispatch

def file_open(file_name):
    abs_path = os.path.abspath(file_name)
    if platform.system() == 'Windows':
        sp.run(f'start {abs_path}', shell=True)
    elif platform.system() == 'Linux':
        sp.run(['xdg-open', f'{abs_path}'])
    else:
        raise NotImplementedError

class Copy_xl(object):
    """
    Copy range from sheet to another
    """
    def __init__(self, path1='', path2=''):
        """
        define source and destination path's
        """
        self.path1 = path1
        self.path2 = path2

    def loadbooks(self, sourcefile, destfile):
        self.sourcefile = xl.open(filename='%s%s' % (self.path1, sourcefile), keep_vba=True)   # xlrd.open_workbook(filename='%s%s' % (self.path1, sourcefile))
        self.destfile = xl.open(filename='%s%s' % (self.path2, destfile), keep_vba=True)   # xlrd.open_workbook(filename='%s%s' % (self.path2, destfile))
        self.sh = self.sourcefile.get_sheet_by_name('annex_excel_phase2')
        self.sh2 = self.destfile.get_sheet_by_name('auto')

    # def isloaded(self):
        # y = False
        # try:
            # self.sourcefile.sheet_names()
            # self.destfile.sheet_names()
            # y = True
            # print(y)
        # except:
            # y = False
            # print(y)

    # def set_sheets(self, sh, sh2):
        # wbname = self.sourcefile
        # wb2name = self.destfile
        # self.sh = wbname.sheet_by_name(sh)  # string format
        # self.sh2 = wb2name.sheet_by_name(sh2)  # string format
        # if wbname.sheet_loaded(sh): print('...source sheet loaded succesfully: ', sh)
        # if wb2name.sheet_loaded(sh2): print('...destination sheet loaded succesfully: ', sh2)

    def open_workbooks(self, osourcefile, odestfile):
        w32xl = Dispatch("Excel.Application")
        w32xl.Visible = True
        self.osourcefile = w32xl.Workbooks.Open(Filename='%s%s' % (self.path1, osourcefile))
        self.odestfile = w32xl.Workbooks.Open(Filename='%s%s' % (self.path2, odestfile))

    def open_sheets(self, sh3, sh4):
        wb3name = self.osourcefile
        wb4name = self.odestfile
        self.sh3 = wb3name.Worksheets(sh3)
        self.sh4 = wb4name.Worksheets(sh4)

    def copy_paste(self, fr_row, fr_col, to_col):
        self.rtocopy = self.sh3.Range(self.sh3.Cells(fr_row, fr_col), self.sh3.Cells(self.sh.max_row, fr_col))
        self.rtopaste = self.sh4.Range(self.sh4.Cells(self.sh2.max_row + 1, to_col), self.sh4.Cells(self.sh2.max_row + self.sh.max_row, to_col))
        self.rtocopy.Copy(self.rtopaste)
        print('...closing source')
        self.osourcefile.Close(SaveChanges=True)
        print('...copy')
        self.sh4.Cells(self.sh2.max_row, to_col).Copy()
        print('...paste')
        self.sh4.Range(self.sh4.Cells(self.sh2.max_row + 1, to_col), self.sh4.Cells(self.sh2.max_row + self.sh.max_row, to_col)).PasteSpecial(Paste=-4122)
        print('...format')
        self.odestfile.Close(SaveChanges=True)
        #         p = '|/-\\|-\\|'
        #         for i in p:
        #             sleep(0.5)
        #             print(i, end='\r')
